function report_amortization_and_interest(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportAmortizationAndInterestWidget = reporting.Base.extend({
        template: 'ReportAmortizationAndInterest',
        rowsData : [],
        content : [],
        Order: '',
        modules: ['point_of_sale'],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'change #current-date' : 'ShowDateRange',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var self = this;
            var table = this.$el.find('#xtable');
            table.bootstrapTable({
                data : self.rowsData,
                onExpandRow: function (index, row, $detail) {
                    self.expandTable($detail,row.number);
                }
            });
            var date = new model.eiru_reports.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }

        },

        fetchInitial: function () {
            var self = this;
            self.fetchDataSQL().then(function (DataSQL) {
                return DataSQL;
            }).then(function(DataSQL) {
                self.ResCompany = DataSQL.companies;
                if(self.ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(self.ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                self.ResStore = DataSQL.stores;
                if(self.ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(self.ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                self.AccountJournal = DataSQL.journals;
                if(self.AccountJournal.length > 1){
                    self.$el.find('#current-journal').append('<option value="9999999">Todas las Facturas</option>');
                    _.each(self.AccountJournal,function(item){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.journal').css('display','none');
                }
                self.ResCompanyLogo = DataSQL.company_logo;
                self.AccountInvoice = DataSQL.invoices;
                self.AccountInvoiceLine = DataSQL.invoice_lines;
                self.AccountMoveLine = DataSQL.move_lines;
                self.AccountVoucher = DataSQL.vouchers;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });

            return self.BuildTable();
        },

        fetchDataSQL: function() {
            var self = this;
            var data = $.get('/report-crifin-credit-utility');
            return data;
        },

        getAccountMoveLine: function (number) {
            var self = this;
            var lines = _.filter(self.AccountMoveLine,function (item) {
                return item.number == number;
            });
            var x = lines.length;
            var i = 1;
            var content =_.map(lines, function(item){
                item.description = 'Cuota ' + i +' / ' + x;
                i++;
                return item;
            });
            return content;
        },

        getAccountVoucher: function (number) {
            var self = this;
            var valor = _.reduce(_.map(self.AccountVoucher, function (map) {
                if(map.reference == number){
                    return map.amount_currency;
                }else{
                    return 0;
                }
            }), function (memo, num) {
                return memo + num;
            });
            return valor;
        },

        getAccountInvoiceLine: function (id) {
            var self = this;
            return _.flatten(_.filter(self.AccountInvoiceLine,function (item){
                return item.invoice_id == id;
            }));
        },

        getContent: function (id) {
            var self = this;
            var content = self.AccountInvoice;

            var company = $('#current-company').val();
            var store = $('#current-store').val();
            var journal = $('#current-journal').val();
            var state = $('#current-state').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();

            if(company && company != 9999999){
                content = _.filter(content,function (item) {
                    return item.company_id == company;
                });
            }

            if(store && store != 9999999){
                content = _.filter(content,function (item) {
                    return item.store_id == store;
                });
            }

            if(journal && journal != 9999999){
                content = _.filter(content,function (item) {
                    return item.journal_id == journal;
                });
            }

            if(state && state != 9999999){
                content = _.filter(content,function (item) {
                    return item.state == state;
                });
            }

            if(date && date != 9999999){
                if(date == 'range'){
                    if(desde){
                        date = desde.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.filter(content,function (item) {
                            return item.date >= date;
                        });
                    }
                    if(hasta){
                        date = hasta.split('/');
                        date = (date[2]+"-"+date[1]+"-"+date[0]);
                        content = _.filter(content,function (item) {
                            return item.date <= date;
                        });
                    }
                }
                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    content = _.filter(content,function (item) {
                        return item.date == today;
                    });
                }
                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    content = _.filter(content,function (item) {
                        return item.date == yesterday;
                    });
                }
                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    content = _.filter(content,function (item) {
                        return moment(item.date).format('YYYY-MM') == currentMonth;
                    });
                }
                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    content = _.filter(content,function (item) {
                        return moment(item.date).format('YYYY-MM') == lastMonth;
                    });
                }
            }

            return content;
        },

        BuildTable: function(){
            var self = this;
            console.log(self);
            var columns = [];
            var data = [];
            var AccountInvoice = self.getContent();
            var CurrencyBase = self.ResCompany[0].currency_id;
            _.each(AccountInvoice,function(item) {
                if(item.is_interest != true){
                    var pagado = self.getAccountVoucher(item.number);
                    var AccountInvoiceLine = self.getAccountInvoiceLine(item.invoice_id);
                    var capital = _.reduce(_.map(AccountInvoiceLine, function (map) {
                        if(!map.is_interest){
                            return map.quantity * map.price_unit;
                        }else{
                            return 0;
                        }
                    }), function (memo, num) {
                        return memo + num;
                    });

                    var interes = _.reduce(_.map(AccountInvoiceLine, function (map) {
                        if(map.is_interest){
                            return map.quantity * map.price_unit;
                        }else{
                            return 0;
                        }
                    }), function (memo, num) {
                        return memo + num;
                    });

                    data.push({
                        /*
                        ########################
                            ID
                        ########################
                        */
                        id:item.invoice_id,
                        /*
                        ########################
                            DATOS FORMATADOS
                        ########################
                        */
                        number:item.number,
                        origin:item.origin,
                        customer_name:item.customer_name,
                        date_invoice:moment(item.date).format('DD/MM/YYYY'),
                        capital_amount:accounting.formatMoney(capital,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                        interest_amount:accounting.formatMoney(interes,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                        amount:accounting.formatMoney(item.amount,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                        residual:accounting.formatMoney(item.amount - pagado,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                        /*
                        ########################
                            DATOS SIN FORMATO
                        ########################
                        */
                        date:item.date,
                        capital_amount_value: capital,
                        interest_amount_value:interes,
                        amount_value:item.amount,
                        residual_value:item.amount - pagado,
                    });
                }
            });
            data.sort(function (a, b) {
                if (a.date > b.date) {
                    return -1;
                }
                if (a.date < b.date) {
                    return 1;
                }
                return 0;
            });
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();
        },

        expandTable: function($detail,number) {
            var self = this;
            self.BuildSubTable($detail.html('<table data-classes="table table-condensed" data-buttons-class="oe_button myButton" data-show-export="true" data-show-footer="true" data-footer-style="footerStyle"></table><br/>').find('table'),number);
        },

        BuildSubTable: function($el,number) {
            var self = this;
            var columns = [];
            var data = [];
            var CurrencyBase = self.ResCompany[0].currency_id;

            columns.push({
                field:'description',
                title:'Descripcion',
                align:'center',
                footerFormatter:'Totales'
            });

            columns.push({
                field:'date_maturity',
                title:'Vencimiento',
                align:'center',
            });

            columns.push({
                field:'capital_residual',
                title:'Saldo del Prestamo',
                align:'right',
                with:'12%',
                footerFormatter:'0'
            });

            columns.push({
                field:'interest_amount',
                title:'Interes',
                align:'right',
                with:'12%',
                footerFormatter:'InterestAmountFormatter'
            });

            columns.push({
                field:'capital_amount',
                title:'Amortizacion',
                align:'right',
                with:'12%',
                footerFormatter:'CapitalAmountFormatter'
            });

            columns.push({
                field:'quota',
                title:'Monto de la cuota',
                align:'right',
                with:'12%',
                footerFormatter:'QuotaFormatter'
            });

            columns.push({
                field:'quota_residual',
                title:'Saldo de la cuota',
                align:'right',
                with:'12%',
                footerFormatter:'QuotaResidualFormatter'
            });

            columns.push({
                field:'interest_receive',
                title:'Interes Cobrado',
                align:'right',
                with:'12%',
                footerFormatter:'InterestReceiveFormatter'
            });

            columns.push({
                field:'capital_receive',
                title:'Capital Recuperado',
                align:'right',
                with:'12%',
                footerFormatter:'CapitalReceiveFormatter'
            });

            var AccountMoveLine = self.getAccountMoveLine(number);
            var AccountInvoice =  _.flatten(_.filter(self.AccountInvoice,function (item){
                return item.number == number;
            }));
            var AccountInvoiceLine = self.getAccountInvoiceLine(AccountInvoice[0].invoice_id);
            var capital = AccountInvoice[0].amount;
            var cant_cuota = AccountMoveLine.length;

            var amortizacion = _.reduce(_.map(AccountInvoiceLine, function (map) {
                if(!map.is_interest){
                    return map.quantity * map.price_unit;
                }else{
                    return 0;
                }
            }), function (memo, num) {
                return memo + num;
            });

            var interes = _.reduce(_.map(AccountInvoiceLine, function (map) {
                if(map.is_interest){
                    return map.quantity * map.price_unit;
                }else{
                    return 0;
                }
            }), function (memo, num) {
                return memo + num;
            });

            var interest_amount = interes / cant_cuota;
            var capital_amount = amortizacion / cant_cuota;
            var capital_receive = 0;
            var interest_receive = 0;
            var razon_capital = (capital - interes) / capital;
            var razon_interes = interes / capital;
            _.each(AccountMoveLine,function(item) {
                if(item.number == number){
                    capital_receive = 0;
                    interest_receive = 0;
                    if(item.debit > 0 && item.date_maturity != false){
                        if(item.reconcile_partial_id == null){
                            var residual = item.debit;
                        }else{
                            var pagado = self.getAccountVoucher(item.number);
                            var x = 0;
                            var band = true;
                            _.each(AccountMoveLine,function(i) {
                                x += i.debit;
                                var saldo = Math.abs(pagado - x);
                                if(AccountMoveLine.length == 1){
                                    residual = saldo;
                                    band = false;
                                }
                                if(saldo < i.debit && band == true){
                                    residual = i.debit - saldo;
                                    if((razon_interes * item.debit) >= saldo){
                                        interest_receive = saldo;
                                    }else{
                                        interest_receive = razon_interes * item.debit;
                                        capital_receive = saldo - (razon_interes * item.debit);
                                    }
                                    band = false;
                                }
                            });
                        }
                        if(item.reconcile_id != null){
                            residual = 0;
                            interest_receive = razon_interes * item.debit;
                            capital_receive = razon_capital * item.debit;
                        }

                        data.push({
                            /*
                            ########################
                                DATOS FORMATADOS
                            ########################
                            */
                            description:item.description,
                            date:item.date_maturity,
                            date_maturity: moment(item.date_maturity).format('DD/MM/YYYY'),
                            capital_residual: accounting.formatMoney(capital,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                            interest_amount: accounting.formatMoney(razon_interes * item.debit,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                            capital_amount: accounting.formatMoney(razon_capital * item.debit,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                            quota: accounting.formatMoney(item.debit,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                            quota_residual: accounting.formatMoney(residual,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                            interest_receive:accounting.formatMoney(interest_receive,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                            capital_receive:accounting.formatMoney(capital_receive,'',CurrencyBase.decimal_places,CurrencyBase.thousands_separator,CurrencyBase.decimal_separator),
                            /*
                            ########################
                                DATOS FORMATADOS
                            ########################
                            */

                            interest_amount_value:razon_interes * item.debit,
                            capital_amount_value:razon_capital * item.debit,
                            quota_value:item.debit,
                            quota_residual_value:residual,
                            interest_receive_value:interest_receive,
                            capital_receive_value:capital_receive,
                        });
                        capital = capital - item.debit;
                    }
                }
            });
            $el.bootstrapTable({
                columns: columns,
                data: data,
            });
        },

        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#xtable');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            GET RES COMPANY
        ====================================================================*/
        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompanyLogo,function (item) {
                return item.id == id;
            });
        },

        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            var CurrencyBase;
            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
                CurrencyBase = self.ResCompany[0].currency_id;
            }else{
                ResCompany = self.ResCompanyLogo[0];
                CurrencyBase = self.ResCompany[0].currency_id;
            }
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#xtable");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');

            var capital_amount = InvoiceCapitalFormatter(row);
            var interest_amount = InvoiceInterestFormatter(row);
            var amount = InvoiceAmountFormatter(row);
            var residual = InvoiceResidualFormatter(row);

            row.push({
                number:'Totales',
                capital_amount:capital_amount,
                interest_amount:interest_amount,
                amount:amount,
                residual:residual,
            });

            if (action === 'pdf') {
                var data = _.map(column, function (val){
                    return val.field;
                });
                _.each(_.map(column,function(val){
                    return val;
                }), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });

                var pdf_title = 'Amortizaciones e Intereses';
                var pdf_type = '';
                var pdf_name = 'amortizaciones_e_intereses';
                var pdf_columnStyles =  {
                    number:{columnWidth: 20, halign:'left'},
                    origin:{columnWidth: 20, halign:'left'},
                    customer_name:{halign:'left'},
                    date_invoice:{columnWidth: 20, halign:'left'},
                    capital_amount :{columnWidth: 25, halign:'right'},
                    interest_amount :{columnWidth: 25, halign:'right'},
                    amount :{columnWidth: 25, halign:'right'},
                    residual:{columnWidth: 25, halign:'right'},
                };

                var filter = self.getFilter();
                var pdf = new model.eiru_reports.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
                );
            }
        },

        getFilter: function(){
            var self = this;
            var company = self.$el.find('#current-company').val();
            var store = self.$el.find('#current-store').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var filter = [];
            var fecha;
            if(company && company){
                var ResCompany = _.filter(self.ResCompany, function(item){
                    return item.id == company;
                });
                filter.push({
                    title:'Empresa',
                    value: ResCompany[0].name,
                });
            }
            if(store && store != 9999999){
                var ResStore =  _.filter(self.ResStore,function (item) {
                   return item.id == store;
                });
                filter.push({
                   title: 'Sucursal',
                   value:  ResStore[0].name,
                });
            }

            if(date && date != 9999999){
                moment.locale('es', {
                    months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
                });
                if(date == 'range'){
                    filter.push({
                        title: 'Fecha',
                        value:  desde +' al '+hasta,
                    });
                    } else {
                        if(date == 'today'){
                            fecha = moment().format('DD/MM/YYYY');
                        }
                        if(date == 'yesterday'){
                            fecha = moment().add(-1,'days').format('DD/MM/YYYY');
                        }
                        if(date == 'currentMonth'){
                            fecha = moment().format('MMMM/YYYY');
                        }
                        if(date == 'lastMonth'){
                            fecha = moment().add(-1,'months').format('MMMM/YYYY');
                        }
                        filter.push({
                            title: 'Fecha',
                            value:  fecha,
                        });
                    }
                }
           return filter;
        },







    });
}
